/* auxiliary plans for Moise agents */

// keep focused on schemes that my groups are responsible for
@l_focus_on_my_scheme[atomic]
+schemes(L)[workspace(_,W)] 
   <- cartago.set_current_wsp(W);
      for ( .member(S,L) ) {
         lookupArtifact(S,ArtId);
         focus(ArtId)
      }.

// the goal !focus_org_art is produced by the JaCaMo launcher for the agent to focus on initial artifacts
+!focus_moise_art([],_).
+!focus_moise_art(L,0) <- .print("Error focusing on organisational artifacts ",L).

@l_focus_org_art[atomic]
+!focus_moise_art([art_org(W,H,A)|T],Try)
   <- !join_workspace(W,H); 
      //cartago.set_current_wsp(W);
      //.print("focusing on ",A);
      lookupArtifact(A,AId);
      focus(AId);
      !focus_moise_art(T,Try).
-!focus_moise_art(L,Try)
   <- //.print("wait a bit to focus on ",L);
      .wait(100);
      !focus_moise_art(L,Try-1).

/* Organisational Plans Required by all agents */

// plans to handle obligations
// obligation to commit to a mission
+obligation(Ag,Norm,committed(Ag,Mission,Scheme),Deadline)[artifact_id(ArtId)]
    : .my_name(Ag)
   <- .print("I am obliged to commit to ",Mission," on ",Scheme,"... doing so");
      commitMission(Mission)[artifact_id(ArtId)]. 

// obligation to achieve a goal      
+obligation(Ag,Norm,achieved(Scheme,Goal,Ag),Deadline)[artifact_id(ArtId)]
    : .my_name(Ag)
   <- //.print(" ---> working to achieve ",Goal," in scheme ",Scheme);
      !Goal[scheme(Scheme)];
      //.print(" <--- done");
      goalAchieved(Goal)[artifact_id(ArtId)].

// an unknown type of obligation was received
+obligation(Ag,Norm,What,DeadLine)  
   : .my_name(Ag)
   <- .print("I am obliged to ",What,", but I don't know what to do!").
