package mw;

/**
 *
 * 2-dimensional vector
 * objects are completely state-less
 *
 */
public class CityDirection implements java.io.Serializable {

    public double x,y;

    public CityDirection(double x,double y){
        this.x=x;
        this.y=y;
    }
    
    public CityDirection(CityPoint from, CityPoint to){
        this.x = to.getX() - from.getX();
        this.y = to.getY() - from.getY();
    }

    public CityDirection sum(CityDirection v){
        return new CityDirection(x+v.x,y+v.y);
    }

    public double abs(){
        return (double)Math.sqrt(x*x+y*y);
    }

    public CityDirection getNormalized(){
        double module=(double)Math.sqrt(x*x+y*y);
        return new CityDirection(x/module,y/module);
    }

    public CityDirection mul(double fact){
        return new CityDirection(x*fact,y*fact);
    }

    public String toString(){
        return "CityDirection("+x+","+y+")";
    }
}
