package mw;

import cartago.*;

/**
 *
 * 2-dimensional point
 * objects are completely state-less
 *
 */
public class CityPoint  implements SituatedWorkspacePoint   {

    private double x,y;

    public CityPoint(double x,double y){
        this.x=x;
        this.y=y;
    }

    public double getDistanceFrom(CityPoint p){
    	double dx = p.x - x;
    	double dy = p.y - y;
        return (double)Math.sqrt(dx*dx+dy*dy);
    }
    
    public double getX(){
    	return x;
    }
    
    public double getY(){
    	return y;
    }
    
    public CityPoint sum(CityDirection v){
        return new CityPoint(x+v.x,y+v.y);
    }

    public CityDirection sub(CityPoint v){
        return new CityDirection(x-v.x,y-v.y);
    }

    public String toString(){
        return ""+x+","+y;
    }

	public Object[] toObsPropParams() {
		return new Object[]{ x, y };
	}

}
