package mw;

import cartago.*;

public class GeoTool extends Artifact {

	CityMap map;
	
	void init(double lat, double lon) throws Exception {
		this.map = new CityMap();
		map.init(lat,lon);
		GeoPoint point = map.getCenter();
		defineObsProperty("map_center",point.getLatitudeDeg(),point.getLongitudeDeg());
    }
	
	@OPERATION void toCityPoint(double lat, double lon, OpFeedbackParam<CityPoint> pos){
		try {
			pos.set(map.toCityPoint(new GeoPoint(lat,lon)));
		} catch (Exception ex){
			failed("invalid_geo_point");
		}
	}
	
	@OPERATION void addPOI(String name, double lat, double lon){
		defineObsProperty("poi",name,lat,lon);
	}
	
}
