package mw;

import java.awt.image.BufferedImage;
import java.net.URL;

import javax.imageio.ImageIO;

public class OSMService {
	
	String basicURL;
	
	public OSMService(String key){
		basicURL = "http://open.mapquestapi.com/staticmap/v4/getmap?key="+key;
	}
	
	public BufferedImage getMap(GeoPoint center, int width, int height, int zoom, GeoPOI[] pois) throws Exception {
		String url = basicURL
				+"&center="+center.toString()
				+"&zoom="+zoom
				+"&size="+width+","+height
				+"&type=map&imagetype=jpeg";
		
		if (pois.length > 0){
			url = url + "&pois=";
			int index = 1;
			for (GeoPOI p: pois){
				url = url +index + "," +  p.getPos() + ",20,20"+ (index < pois.length ? "|" : "" );
				index++;
			}
		}

		URL obj = new URL(url);
		BufferedImage img = null;
		try {
		    img = ImageIO.read(obj);
		} catch (Exception e) {
			e.printStackTrace();
		}		
		//System.out.println("NEW MAP REQ OK: \n"+url);
		return img;
	}

}
