/* auxiliary plans for Moise agents */

// keep focused on schemes that my groups are responsible for
@l_focus_on_my_scheme[atomic]
+schemes(L)[workspace(_,_,W)] 
   <- cartago.set_current_wsp(W);
      for ( .member(S,L) ) {
         lookupArtifact(S,ArtId);
         focus(ArtId)
      }.

// the goal !focus_org_art is produced by the JaCaMo launcher for the agent to focus on initial artifacts
+!jcm__initial_roles([],_).
+!jcm__initial_roles(L,0) <- .print("Error with inicial roles ",L).

@l_focus_org_art[atomic]
+!jcm__initial_roles([role(O,H,G,R)|T],Try)
   <- !join_workspace(O,H); 
      lookupArtifact(G,GId);
      +jcm__art(G,GId);
      focus(GId);
      adoptRole(R)[artifact_id(GId)];
      !jcm__initial_roles(T,Try).
-!jcm__initial_roles(L,Try)
   <- //.print("wait a bit to focus on ",L);
      .wait(100);
      !jcm__initial_roles(L,Try-1).

/* Organisational Plans Required by all agents */

// plans to handle obligations
// obligation to commit to a mission
+obligation(Ag,Norm,committed(Ag,Mission,Scheme),Deadline)[artifact_id(ArtId)]
    : .my_name(Ag)
   <- .print("I am obliged to commit to ",Mission," on ",Scheme,"... doing so");
      commitMission(Mission)[artifact_id(ArtId)]. 

// obligation to achieve a goal      
+obligation(Ag,Norm,achieved(Scheme,Goal,Ag),Deadline)[artifact_id(ArtId)]
    : .my_name(Ag)
   <- //.print(" ---> working to achieve ",Goal," in scheme ",Scheme);
      !Goal[scheme(Scheme)];
      //.print(" <--- done");
      goalAchieved(Goal)[artifact_id(ArtId)].

// an unknown type of obligation was received
+obligation(Ag,Norm,What,DeadLine)  
   : .my_name(Ag)
   <- .print("I am obliged to ",What,", but I don't know what to do!").
